#this import statement allows access to the karamba functions
import karamba

#This the name of the plugin wich will be displayed in the configuration GUI
plugin_name = "My Plugin"
#This is the file name of the plugin's icon on wich the user will click to open it
icon = 'pc.png'
#This is the 'dict' of configurable parameters of the plugin with their default value,
#they have to be edited in the configuration_gui and parameters name must be in the form:
#    "smallword_parameter'sName" where smallword is an abbreviation of the name of the plugin
default_param = {
		"myplugin_parameter1" : value1,
		"myplugin_parameter2" : value2}

#This function is called in the initWidget(widget) function of the theme
#so what is typed here will be executed at once
def init(widget):
	pass

#This class is called when the plugin's icon is clicked, it opens the page of the plugin
#It must have "self.title" wich is the title of the page,
#self.line wich is a small line under the title and all the functions already defined
#Arguments: theme is the path to current theme (string)
#           color is the color of all texts excepted the title in the form of a list [int red, int green, int blue]
#           titleColor : you know what it is
#           conf is the configuration 'dict' you can access your parameters like that conf["smallword_parameter'sName"]
class Plugin:
	
	def __init__(self, widget, theme, color, titleColor, conf):
		self.title = karamba.createText(widget, 36, 34, 150, 20, "My Title")
		karamba.changeTextSize(widget, self.title, 20)
		self.line = karamba.createImage(widget, 31, 58, theme + "line.png")
	
	#This function is used to set text color every time plugin is loaded !NEEDED
	def setTextColor(self, widget, color):
		karamba.changeTextColor(widget, textMeter1, color[0], color[1], color[2])
		karamba.changeTextColor(widget, textMeter2, color[0], color[1], color[2])
	
	#This function is used to set shadows every time plugin is loaded !NEEDED
	def setTextShadow(self, widget, bool):
		karamba.changeTextShadow(widget, textMeter1, int(bool))
		karamba.changeTextShadow(widget, textMeter2, int(bool))
	
	#This function is called in the widgetUpdated(widget) function of the theme
	#which is called every seconds
	def update(self, widget):
		pass
	
	#This function is called in the commandOutput(widget, pid, output) function of the theme
	def commandOutput(self, widget, pid, output):
		pass
	
	#This function is called in the meterClicked(widget, meter, button) function of the theme
	def meterClicked(self, widget, meter, button):
		pass
	
	#This function is called in the widgetClicked(widget, x, y, button) function of the theme
	def widgetClicked(self, widget, x, y, button):
		pass
	
	#This function is called in the widgetMouseMoved(widget, x, y, button) function of the theme
	def widgetMouseMoved(self, widget, x, y, button):
		#Warning:  Don't do anything too intensive here
		#You don't want to run some complex piece of code everytime the mouse moves
		pass
	
	#This function is called in the menuItemClicked(widget, menu, id) function of the theme
	def menuItemClicked(self, widget, menu, id):
		pass
	
	#This function is called in the itemDropped(widget, dropText) function of the theme
	def itemDropped(self, widget, dropText):
		pass
	
	#This function is called in the keyPressed(widget, meter, char) function of the theme
	def keyPressed(self, widget, meter, char):
		pass
	
	#This function is called when another page is to be opened, 
	#all the superkaramba widgets you have created have to be deleted here !NEEDED
	def close(self, widget):
		karamba.deleteText(widget, self.title)
		karamba.deleteImage(widget, self.line)
